from typing import List as _py_List
import java.lang
import java.util


class ClientRequestInfoCollector:
    def addRequest(self, clientRequestInfo: 'ClientRequestInfo') -> bool: ...
    def getApplicationName(self) -> str: ...
    def getFirstRequestStartTime(self) -> java.util.Date: ...
    def getLastAddedRequest(self) -> 'ClientRequestInfo': ...
    def getLastFailedRequest(self) -> 'ClientRequestInfo': ...
    def getLastFinishedRequest(self) -> 'ClientRequestInfo': ...
    def getLocationName(self) -> str: ...
    def getRunningRequests(self) -> _py_List['ClientRequestInfo']: ...
    def getRunningRequestsCount(self) -> int: ...
    def getTotalExceptionsCount(self) -> int: ...
    def getTotalRequestsCount(self) -> int: ...
    def getTotalTimeSpentMillis(self) -> int: ...
    def getUserName(self) -> str: ...
    def removeRequest(self, clientRequestInfo: 'ClientRequestInfo') -> bool: ...

class ClientRequestInfoCollectorCache:
    def getCollectorOrCreateIfNotExist(self, string: str, string2: str, string3: str) -> ClientRequestInfoCollector: ...
    def getCollectorsCount(self) -> int: ...
    def getTimeToLiveMBeansDays(self) -> int: ...
    def setTimeToLiveMBeansDays(self, int: int) -> None: ...

class ClientRequestInfoDataType:
    def getAction(self) -> str: ...
    def getClientApplication(self) -> str: ...
    def getClientLocation(self) -> str: ...
    def getClientUser(self) -> str: ...
    def getElapsedTimeMillis(self) -> int: ...
    def getExceptionClass(self) -> str: ...
    def getExceptionMessage(self) -> str: ...
    def getExceptionStackTrace(self) -> str: ...
    def getFinishTime(self) -> java.util.Date: ...
    def getFinishTimeMillis(self) -> int: ...
    def getNamedArguments(self) -> java.util.Map[str, str]: ...
    def getProperties(self) -> java.util.Map[str, str]: ...
    def getResultValue(self) -> str: ...
    def getStartTime(self) -> java.util.Date: ...
    def getStartTimeMillis(self) -> int: ...
    def getStatus(self) -> str: ...

class ClientRequestInfo(ClientRequestInfoDataType):
    def addNewArgument(self, string: str, string2: str) -> None: ...
    def getAction(self) -> str: ...
    def getClientApplication(self) -> str: ...
    def getClientLocation(self) -> str: ...
    def getClientUser(self) -> str: ...
    def getElapsedTimeMillis(self) -> int: ...
    def getExceptionClass(self) -> str: ...
    def getExceptionMessage(self) -> str: ...
    def getExceptionStackTrace(self) -> str: ...
    def getFinishTime(self) -> java.util.Date: ...
    def getFinishTimeMillis(self) -> int: ...
    def getNamedArguments(self) -> java.util.Map[str, str]: ...
    def getProperties(self) -> java.util.Map[str, str]: ...
    def getResultValue(self) -> str: ...
    def getStartTime(self) -> java.util.Date: ...
    def getStartTimeMillis(self) -> int: ...
    def getStatus(self) -> str: ...
    def hasError(self) -> bool: ...
    def setException(self, throwable: java.lang.Throwable) -> None: ...
    def setProperty(self, string: str, string2: str) -> None: ...
    def setResultValue(self, string: str) -> None: ...
