from typing import Any as _py_Any
from typing import Type as _py_Type
import cern.accsoft.commons.util.userctx
import java.lang
import java.util
import org.springframework.remoting.support


class InstrumentationRemoteInvocationExecutor(cern.accsoft.commons.util.userctx.ContextAwareRemoteInvocationExecutor):
    def __init__(self, list: java.util.List['RemoteInvocationInstrumentation']): ...

class RemoteInstrumentationUtils:
    @classmethod
    def getClassForLogging(cls, object: _py_Any) -> _py_Type[_py_Any]: ...
    @classmethod
    def getClientId(cls, remoteInvocation: org.springframework.remoting.support.RemoteInvocation) -> str: ...
    @classmethod
    def getRbacUser(cls) -> str: ...

class RemoteInvocationInstrumentation:
    def afterInvocationFailure(self, remoteInvocation: org.springframework.remoting.support.RemoteInvocation, object: _py_Any, exception: java.lang.Exception) -> None: ...
    def afterInvocationSuccess(self, remoteInvocation: org.springframework.remoting.support.RemoteInvocation, object: _py_Any, object2: _py_Any) -> None: ...
    def beforeInvocation(self, remoteInvocation: org.springframework.remoting.support.RemoteInvocation, object: _py_Any) -> None: ...

class Slf4jRmiLogger(RemoteInvocationInstrumentation):
    def __init__(self, string: str): ...
    def afterInvocationFailure(self, remoteInvocation: org.springframework.remoting.support.RemoteInvocation, object: _py_Any, exception: java.lang.Exception) -> None: ...
    def afterInvocationSuccess(self, remoteInvocation: org.springframework.remoting.support.RemoteInvocation, object: _py_Any, object2: _py_Any) -> None: ...
    def beforeInvocation(self, remoteInvocation: org.springframework.remoting.support.RemoteInvocation, object: _py_Any) -> None: ...
