from typing import TypeVar as _py_TypeVar
from typing import Type as _py_Type
import cern.japc.core


class ParameterArrayCaller:
    def getValue(self, immutableParameter: cern.japc.core.ImmutableParameter, selector: cern.japc.core.Selector) -> cern.japc.core.FailSafeParameterValue: ...
    def registerParameter(self, immutableParameter: cern.japc.core.ImmutableParameter) -> None: ...
    def startSubscription(self, immutableParameter: cern.japc.core.ImmutableParameter, selector: cern.japc.core.Selector, parameterValueListener: cern.japc.core.ParameterValueListener) -> None: ...
    def stopSubscription(self, immutableParameter: cern.japc.core.ImmutableParameter, selector: cern.japc.core.Selector, parameterValueListener: cern.japc.core.ParameterValueListener) -> None: ...

class ParameterArrayCallerManager:
    def __init__(self): ...
    def generateArrayCallerId(self) -> str: ...
    @classmethod
    def get(cls) -> 'ParameterArrayCallerManager': ...
    _getArrayCaller__T = _py_TypeVar('_getArrayCaller__T', bound=ParameterArrayCaller)  # <T>
    def getArrayCaller(self, class_: _py_Type[_getArrayCaller__T], string: str) -> _getArrayCaller__T: ...

class AbstractParameterArrayCaller(ParameterArrayCaller): ...
