from typing import ClassVar as _py_ClassVar
from typing import overload
import cern.japc.value
import java.io


class ValueBean:
    NON_MUTABLE_MESSAGE: _py_ClassVar[str] = ...
    def getParameterValue(self) -> cern.japc.value.ParameterValue: ...
    def isMutable(self) -> bool: ...
    def makeMutable(self) -> None: ...

class ValueBeanImpl(ValueBean, java.io.Serializable):
    def __init__(self, parameterValue: cern.japc.value.ParameterValue): ...
    def getParameterValue(self) -> cern.japc.value.ParameterValue: ...
    def isMutable(self) -> bool: ...
    def makeMutable(self) -> None: ...
    def toString(self) -> str: ...

class MapValueBean(ValueBeanImpl):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, mapDescriptor: cern.japc.value.MapDescriptor): ...
    @overload
    def __init__(self, mapParameterValue: cern.japc.value.MapParameterValue): ...
    @overload
    def __init__(self, mapParameterValue: cern.japc.value.MapParameterValue, mapDescriptor: cern.japc.value.MapDescriptor): ...
    def setParameterValue(self, mapParameterValue: cern.japc.value.MapParameterValue) -> None: ...

class SimpleValueBean(ValueBeanImpl):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, simpleDescriptor: cern.japc.value.SimpleDescriptor): ...
    @overload
    def __init__(self, simpleParameterValue: cern.japc.value.SimpleParameterValue): ...
    @overload
    def __init__(self, simpleParameterValue: cern.japc.value.SimpleParameterValue, simpleDescriptor: cern.japc.value.SimpleDescriptor): ...
    def setParameterValue(self, simpleParameterValue: cern.japc.value.SimpleParameterValue) -> None: ...
    @classmethod
    def validateReader(cls, simpleParameterValue: cern.japc.value.SimpleParameterValue, simpleDescriptor: cern.japc.value.SimpleDescriptor) -> None: ...
