from typing import List as _py_List
import cern.rbac.common
import cern.rbac.common.impl.serialization.decode


class AbstractTokenDecoder(cern.rbac.common.impl.serialization.decode.TokenDecoder):
    def __init__(self, rbacConfiguration: cern.rbac.common.RbacConfiguration): ...
    def decode(self, byteArray: _py_List[int]) -> cern.rbac.common.impl.serialization.decode.SerializedTokenFields: ...

class SerializedTokenFieldsImpl(cern.rbac.common.impl.serialization.decode.SerializedTokenFields):
    def __init__(self): ...
    def getApplicationName(self) -> str: ...
    def getApplicationTimeout(self) -> int: ...
    def getAuthenticationTime(self) -> int: ...
    def getBody(self) -> _py_List[int]: ...
    def getExpirationTime(self) -> int: ...
    def getExtraFields(self) -> cern.rbac.common.ExtraFields: ...
    def getLocationAddress(self) -> _py_List[int]: ...
    def getLocationName(self) -> str: ...
    def getRoles(self) -> _py_List[cern.rbac.common.Role]: ...
    def getSerialId(self) -> int: ...
    def getSignature(self) -> _py_List[int]: ...
    def getUserAccountType(self) -> cern.rbac.common.UserPrincipal.AccountType: ...
    def getUserEmail(self) -> str: ...
    def getUserFullName(self) -> str: ...
    def getUserName(self) -> str: ...
    def isApplicationCritical(self) -> bool: ...
    def isLocationAuthReq(self) -> bool: ...
    def setApplicationCritical(self, boolean: bool) -> None: ...
    def setApplicationName(self, string: str) -> None: ...
    def setApplicationTimeout(self, int: int) -> None: ...
    def setAuthenticationTime(self, int: int) -> None: ...
    def setBody(self, byteArray: _py_List[int]) -> None: ...
    def setExpirationTime(self, int: int) -> None: ...
    def setExtraFields(self, extraFields: cern.rbac.common.ExtraFields) -> None: ...
    def setLocationAddress(self, byteArray: _py_List[int]) -> None: ...
    def setLocationAuthReq(self, boolean: bool) -> None: ...
    def setLocationName(self, string: str) -> None: ...
    def setRoles(self, roleArray: _py_List[cern.rbac.common.Role]) -> None: ...
    def setSerialId(self, int: int) -> None: ...
    def setSignature(self, byteArray: _py_List[int]) -> None: ...
    def setUserAccountType(self, accountType: cern.rbac.common.UserPrincipal.AccountType) -> None: ...
    def setUserEmail(self, string: str) -> None: ...
    def setUserFullName(self, string: str) -> None: ...
    def setUserName(self, string: str) -> None: ...

class TestTokenDecoderDecorator(AbstractTokenDecoder):
    def __init__(self, abstractTokenDecoder: AbstractTokenDecoder): ...

class TextTokenDecoder(AbstractTokenDecoder):
    def __init__(self, rbacConfiguration: cern.rbac.common.RbacConfiguration): ...
