from typing import List as _py_List
from typing import ClassVar as _py_ClassVar
from typing import overload
import java.io
import java.lang


class CMMException(java.lang.RuntimeException):
    def __init__(self, string: str): ...

class ColorSpace(java.io.Serializable):
    TYPE_XYZ: _py_ClassVar[int] = ...
    TYPE_Lab: _py_ClassVar[int] = ...
    TYPE_Luv: _py_ClassVar[int] = ...
    TYPE_YCbCr: _py_ClassVar[int] = ...
    TYPE_Yxy: _py_ClassVar[int] = ...
    TYPE_RGB: _py_ClassVar[int] = ...
    TYPE_GRAY: _py_ClassVar[int] = ...
    TYPE_HSV: _py_ClassVar[int] = ...
    TYPE_HLS: _py_ClassVar[int] = ...
    TYPE_CMYK: _py_ClassVar[int] = ...
    TYPE_CMY: _py_ClassVar[int] = ...
    TYPE_2CLR: _py_ClassVar[int] = ...
    TYPE_3CLR: _py_ClassVar[int] = ...
    TYPE_4CLR: _py_ClassVar[int] = ...
    TYPE_5CLR: _py_ClassVar[int] = ...
    TYPE_6CLR: _py_ClassVar[int] = ...
    TYPE_7CLR: _py_ClassVar[int] = ...
    TYPE_8CLR: _py_ClassVar[int] = ...
    TYPE_9CLR: _py_ClassVar[int] = ...
    TYPE_ACLR: _py_ClassVar[int] = ...
    TYPE_BCLR: _py_ClassVar[int] = ...
    TYPE_CCLR: _py_ClassVar[int] = ...
    TYPE_DCLR: _py_ClassVar[int] = ...
    TYPE_ECLR: _py_ClassVar[int] = ...
    TYPE_FCLR: _py_ClassVar[int] = ...
    CS_sRGB: _py_ClassVar[int] = ...
    CS_LINEAR_RGB: _py_ClassVar[int] = ...
    CS_CIEXYZ: _py_ClassVar[int] = ...
    CS_PYCC: _py_ClassVar[int] = ...
    CS_GRAY: _py_ClassVar[int] = ...
    def fromCIEXYZ(self, floatArray: _py_List[float]) -> _py_List[float]: ...
    def fromRGB(self, floatArray: _py_List[float]) -> _py_List[float]: ...
    @classmethod
    def getInstance(cls, int: int) -> 'ColorSpace': ...
    def getMaxValue(self, int: int) -> float: ...
    def getMinValue(self, int: int) -> float: ...
    def getName(self, int: int) -> str: ...
    def getNumComponents(self) -> int: ...
    def getType(self) -> int: ...
    def isCS_sRGB(self) -> bool: ...
    def toCIEXYZ(self, floatArray: _py_List[float]) -> _py_List[float]: ...
    def toRGB(self, floatArray: _py_List[float]) -> _py_List[float]: ...

class ICC_Profile(java.io.Serializable):
    CLASS_INPUT: _py_ClassVar[int] = ...
    CLASS_DISPLAY: _py_ClassVar[int] = ...
    CLASS_OUTPUT: _py_ClassVar[int] = ...
    CLASS_DEVICELINK: _py_ClassVar[int] = ...
    CLASS_COLORSPACECONVERSION: _py_ClassVar[int] = ...
    CLASS_ABSTRACT: _py_ClassVar[int] = ...
    CLASS_NAMEDCOLOR: _py_ClassVar[int] = ...
    icSigXYZData: _py_ClassVar[int] = ...
    icSigLabData: _py_ClassVar[int] = ...
    icSigLuvData: _py_ClassVar[int] = ...
    icSigYCbCrData: _py_ClassVar[int] = ...
    icSigYxyData: _py_ClassVar[int] = ...
    icSigRgbData: _py_ClassVar[int] = ...
    icSigGrayData: _py_ClassVar[int] = ...
    icSigHsvData: _py_ClassVar[int] = ...
    icSigHlsData: _py_ClassVar[int] = ...
    icSigCmykData: _py_ClassVar[int] = ...
    icSigCmyData: _py_ClassVar[int] = ...
    icSigSpace2CLR: _py_ClassVar[int] = ...
    icSigSpace3CLR: _py_ClassVar[int] = ...
    icSigSpace4CLR: _py_ClassVar[int] = ...
    icSigSpace5CLR: _py_ClassVar[int] = ...
    icSigSpace6CLR: _py_ClassVar[int] = ...
    icSigSpace7CLR: _py_ClassVar[int] = ...
    icSigSpace8CLR: _py_ClassVar[int] = ...
    icSigSpace9CLR: _py_ClassVar[int] = ...
    icSigSpaceACLR: _py_ClassVar[int] = ...
    icSigSpaceBCLR: _py_ClassVar[int] = ...
    icSigSpaceCCLR: _py_ClassVar[int] = ...
    icSigSpaceDCLR: _py_ClassVar[int] = ...
    icSigSpaceECLR: _py_ClassVar[int] = ...
    icSigSpaceFCLR: _py_ClassVar[int] = ...
    icSigInputClass: _py_ClassVar[int] = ...
    icSigDisplayClass: _py_ClassVar[int] = ...
    icSigOutputClass: _py_ClassVar[int] = ...
    icSigLinkClass: _py_ClassVar[int] = ...
    icSigAbstractClass: _py_ClassVar[int] = ...
    icSigColorSpaceClass: _py_ClassVar[int] = ...
    icSigNamedColorClass: _py_ClassVar[int] = ...
    icPerceptual: _py_ClassVar[int] = ...
    icRelativeColorimetric: _py_ClassVar[int] = ...
    icMediaRelativeColorimetric: _py_ClassVar[int] = ...
    icSaturation: _py_ClassVar[int] = ...
    icAbsoluteColorimetric: _py_ClassVar[int] = ...
    icICCAbsoluteColorimetric: _py_ClassVar[int] = ...
    icSigHead: _py_ClassVar[int] = ...
    icSigAToB0Tag: _py_ClassVar[int] = ...
    icSigAToB1Tag: _py_ClassVar[int] = ...
    icSigAToB2Tag: _py_ClassVar[int] = ...
    icSigBlueColorantTag: _py_ClassVar[int] = ...
    icSigBlueMatrixColumnTag: _py_ClassVar[int] = ...
    icSigBlueTRCTag: _py_ClassVar[int] = ...
    icSigBToA0Tag: _py_ClassVar[int] = ...
    icSigBToA1Tag: _py_ClassVar[int] = ...
    icSigBToA2Tag: _py_ClassVar[int] = ...
    icSigCalibrationDateTimeTag: _py_ClassVar[int] = ...
    icSigCharTargetTag: _py_ClassVar[int] = ...
    icSigCopyrightTag: _py_ClassVar[int] = ...
    icSigCrdInfoTag: _py_ClassVar[int] = ...
    icSigDeviceMfgDescTag: _py_ClassVar[int] = ...
    icSigDeviceModelDescTag: _py_ClassVar[int] = ...
    icSigDeviceSettingsTag: _py_ClassVar[int] = ...
    icSigGamutTag: _py_ClassVar[int] = ...
    icSigGrayTRCTag: _py_ClassVar[int] = ...
    icSigGreenColorantTag: _py_ClassVar[int] = ...
    icSigGreenMatrixColumnTag: _py_ClassVar[int] = ...
    icSigGreenTRCTag: _py_ClassVar[int] = ...
    icSigLuminanceTag: _py_ClassVar[int] = ...
    icSigMeasurementTag: _py_ClassVar[int] = ...
    icSigMediaBlackPointTag: _py_ClassVar[int] = ...
    icSigMediaWhitePointTag: _py_ClassVar[int] = ...
    icSigNamedColor2Tag: _py_ClassVar[int] = ...
    icSigOutputResponseTag: _py_ClassVar[int] = ...
    icSigPreview0Tag: _py_ClassVar[int] = ...
    icSigPreview1Tag: _py_ClassVar[int] = ...
    icSigPreview2Tag: _py_ClassVar[int] = ...
    icSigProfileDescriptionTag: _py_ClassVar[int] = ...
    icSigProfileSequenceDescTag: _py_ClassVar[int] = ...
    icSigPs2CRD0Tag: _py_ClassVar[int] = ...
    icSigPs2CRD1Tag: _py_ClassVar[int] = ...
    icSigPs2CRD2Tag: _py_ClassVar[int] = ...
    icSigPs2CRD3Tag: _py_ClassVar[int] = ...
    icSigPs2CSATag: _py_ClassVar[int] = ...
    icSigPs2RenderingIntentTag: _py_ClassVar[int] = ...
    icSigRedColorantTag: _py_ClassVar[int] = ...
    icSigRedMatrixColumnTag: _py_ClassVar[int] = ...
    icSigRedTRCTag: _py_ClassVar[int] = ...
    icSigScreeningDescTag: _py_ClassVar[int] = ...
    icSigScreeningTag: _py_ClassVar[int] = ...
    icSigTechnologyTag: _py_ClassVar[int] = ...
    icSigUcrBgTag: _py_ClassVar[int] = ...
    icSigViewingCondDescTag: _py_ClassVar[int] = ...
    icSigViewingConditionsTag: _py_ClassVar[int] = ...
    icSigChromaticityTag: _py_ClassVar[int] = ...
    icSigChromaticAdaptationTag: _py_ClassVar[int] = ...
    icSigColorantOrderTag: _py_ClassVar[int] = ...
    icSigColorantTableTag: _py_ClassVar[int] = ...
    icHdrSize: _py_ClassVar[int] = ...
    icHdrCmmId: _py_ClassVar[int] = ...
    icHdrVersion: _py_ClassVar[int] = ...
    icHdrDeviceClass: _py_ClassVar[int] = ...
    icHdrColorSpace: _py_ClassVar[int] = ...
    icHdrPcs: _py_ClassVar[int] = ...
    icHdrDate: _py_ClassVar[int] = ...
    icHdrMagic: _py_ClassVar[int] = ...
    icHdrPlatform: _py_ClassVar[int] = ...
    icHdrFlags: _py_ClassVar[int] = ...
    icHdrManufacturer: _py_ClassVar[int] = ...
    icHdrModel: _py_ClassVar[int] = ...
    icHdrAttributes: _py_ClassVar[int] = ...
    icHdrRenderingIntent: _py_ClassVar[int] = ...
    icHdrIlluminant: _py_ClassVar[int] = ...
    icHdrCreator: _py_ClassVar[int] = ...
    icHdrProfileID: _py_ClassVar[int] = ...
    icTagType: _py_ClassVar[int] = ...
    icTagReserved: _py_ClassVar[int] = ...
    icCurveCount: _py_ClassVar[int] = ...
    icCurveData: _py_ClassVar[int] = ...
    icXYZNumberX: _py_ClassVar[int] = ...
    def getColorSpaceType(self) -> int: ...
    @overload
    def getData(self) -> _py_List[int]: ...
    @overload
    def getData(self, int: int) -> _py_List[int]: ...
    @classmethod
    @overload
    def getInstance(cls, byteArray: _py_List[int]) -> 'ICC_Profile': ...
    @classmethod
    @overload
    def getInstance(cls, int: int) -> 'ICC_Profile': ...
    @classmethod
    @overload
    def getInstance(cls, inputStream: java.io.InputStream) -> 'ICC_Profile': ...
    @classmethod
    @overload
    def getInstance(cls, string: str) -> 'ICC_Profile': ...
    def getMajorVersion(self) -> int: ...
    def getMinorVersion(self) -> int: ...
    def getNumComponents(self) -> int: ...
    def getPCSType(self) -> int: ...
    def getProfileClass(self) -> int: ...
    def setData(self, int: int, byteArray: _py_List[int]) -> None: ...
    @overload
    def write(self, outputStream: java.io.OutputStream) -> None: ...
    @overload
    def write(self, string: str) -> None: ...

class ProfileDataException(java.lang.RuntimeException):
    def __init__(self, string: str): ...

class ICC_ColorSpace(ColorSpace):
    def __init__(self, iCC_Profile: ICC_Profile): ...
    def fromCIEXYZ(self, floatArray: _py_List[float]) -> _py_List[float]: ...
    def fromRGB(self, floatArray: _py_List[float]) -> _py_List[float]: ...
    def getMaxValue(self, int: int) -> float: ...
    def getMinValue(self, int: int) -> float: ...
    def getProfile(self) -> ICC_Profile: ...
    def toCIEXYZ(self, floatArray: _py_List[float]) -> _py_List[float]: ...
    def toRGB(self, floatArray: _py_List[float]) -> _py_List[float]: ...

class ICC_ProfileGray(ICC_Profile):
    def getGamma(self) -> float: ...
    def getMediaWhitePoint(self) -> _py_List[float]: ...
    def getTRC(self) -> _py_List[int]: ...

class ICC_ProfileRGB(ICC_Profile):
    REDCOMPONENT: _py_ClassVar[int] = ...
    GREENCOMPONENT: _py_ClassVar[int] = ...
    BLUECOMPONENT: _py_ClassVar[int] = ...
    def getGamma(self, int: int) -> float: ...
    def getMatrix(self) -> _py_List[_py_List[float]]: ...
    def getMediaWhitePoint(self) -> _py_List[float]: ...
    def getTRC(self, int: int) -> _py_List[int]: ...
