from typing import Any as _py_Any
from typing import List as _py_List
from typing import ClassVar as _py_ClassVar
from typing import overload
import java
import java.awt
import java.io
import java.lang
import java.util


class AffineTransform(java.lang.Cloneable, java.io.Serializable):
    TYPE_IDENTITY: _py_ClassVar[int] = ...
    TYPE_TRANSLATION: _py_ClassVar[int] = ...
    TYPE_UNIFORM_SCALE: _py_ClassVar[int] = ...
    TYPE_GENERAL_SCALE: _py_ClassVar[int] = ...
    TYPE_MASK_SCALE: _py_ClassVar[int] = ...
    TYPE_FLIP: _py_ClassVar[int] = ...
    TYPE_QUADRANT_ROTATION: _py_ClassVar[int] = ...
    TYPE_GENERAL_ROTATION: _py_ClassVar[int] = ...
    TYPE_MASK_ROTATION: _py_ClassVar[int] = ...
    TYPE_GENERAL_TRANSFORM: _py_ClassVar[int] = ...
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float): ...
    @overload
    def __init__(self, doubleArray: _py_List[float]): ...
    @overload
    def __init__(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float): ...
    @overload
    def __init__(self, floatArray: _py_List[float]): ...
    @overload
    def __init__(self, affineTransform: 'AffineTransform'): ...
    def clone(self) -> _py_Any: ...
    def concatenate(self, affineTransform: 'AffineTransform') -> None: ...
    def createInverse(self) -> 'AffineTransform': ...
    def createTransformedShape(self, shape: java.awt.Shape) -> java.awt.Shape: ...
    @overload
    def deltaTransform(self, point2D: 'Point2D', point2D2: 'Point2D') -> 'Point2D': ...
    @overload
    def deltaTransform(self, doubleArray: _py_List[float], int: int, doubleArray2: _py_List[float], int2: int, int3: int) -> None: ...
    def equals(self, object: _py_Any) -> bool: ...
    def getDeterminant(self) -> float: ...
    def getMatrix(self, doubleArray: _py_List[float]) -> None: ...
    @classmethod
    @overload
    def getQuadrantRotateInstance(cls, int: int) -> 'AffineTransform': ...
    @classmethod
    @overload
    def getQuadrantRotateInstance(cls, int: int, double: float, double2: float) -> 'AffineTransform': ...
    @classmethod
    @overload
    def getRotateInstance(cls, double: float) -> 'AffineTransform': ...
    @classmethod
    @overload
    def getRotateInstance(cls, double: float, double2: float) -> 'AffineTransform': ...
    @classmethod
    @overload
    def getRotateInstance(cls, double: float, double2: float, double3: float) -> 'AffineTransform': ...
    @classmethod
    @overload
    def getRotateInstance(cls, double: float, double2: float, double3: float, double4: float) -> 'AffineTransform': ...
    @classmethod
    def getScaleInstance(cls, double: float, double2: float) -> 'AffineTransform': ...
    def getScaleX(self) -> float: ...
    def getScaleY(self) -> float: ...
    @classmethod
    def getShearInstance(cls, double: float, double2: float) -> 'AffineTransform': ...
    def getShearX(self) -> float: ...
    def getShearY(self) -> float: ...
    @classmethod
    def getTranslateInstance(cls, double: float, double2: float) -> 'AffineTransform': ...
    def getTranslateX(self) -> float: ...
    def getTranslateY(self) -> float: ...
    def getType(self) -> int: ...
    def hashCode(self) -> int: ...
    @overload
    def inverseTransform(self, point2D: 'Point2D', point2D2: 'Point2D') -> 'Point2D': ...
    @overload
    def inverseTransform(self, doubleArray: _py_List[float], int: int, doubleArray2: _py_List[float], int2: int, int3: int) -> None: ...
    def invert(self) -> None: ...
    def isIdentity(self) -> bool: ...
    def preConcatenate(self, affineTransform: 'AffineTransform') -> None: ...
    @overload
    def quadrantRotate(self, int: int) -> None: ...
    @overload
    def quadrantRotate(self, int: int, double: float, double2: float) -> None: ...
    @overload
    def rotate(self, double: float) -> None: ...
    @overload
    def rotate(self, double: float, double2: float) -> None: ...
    @overload
    def rotate(self, double: float, double2: float, double3: float) -> None: ...
    @overload
    def rotate(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    def scale(self, double: float, double2: float) -> None: ...
    def setToIdentity(self) -> None: ...
    @overload
    def setToQuadrantRotation(self, int: int) -> None: ...
    @overload
    def setToQuadrantRotation(self, int: int, double: float, double2: float) -> None: ...
    @overload
    def setToRotation(self, double: float) -> None: ...
    @overload
    def setToRotation(self, double: float, double2: float) -> None: ...
    @overload
    def setToRotation(self, double: float, double2: float, double3: float) -> None: ...
    @overload
    def setToRotation(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    def setToScale(self, double: float, double2: float) -> None: ...
    def setToShear(self, double: float, double2: float) -> None: ...
    def setToTranslation(self, double: float, double2: float) -> None: ...
    @overload
    def setTransform(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
    @overload
    def setTransform(self, affineTransform: 'AffineTransform') -> None: ...
    def shear(self, double: float, double2: float) -> None: ...
    def toString(self) -> str: ...
    @overload
    def transform(self, point2D: 'Point2D', point2D2: 'Point2D') -> 'Point2D': ...
    @overload
    def transform(self, doubleArray: _py_List[float], int: int, doubleArray2: _py_List[float], int2: int, int3: int) -> None: ...
    @overload
    def transform(self, doubleArray: _py_List[float], int: int, floatArray: _py_List[float], int2: int, int3: int) -> None: ...
    @overload
    def transform(self, floatArray: _py_List[float], int: int, doubleArray: _py_List[float], int2: int, int3: int) -> None: ...
    @overload
    def transform(self, floatArray: _py_List[float], int: int, floatArray2: _py_List[float], int2: int, int3: int) -> None: ...
    @overload
    def transform(self, point2DArray: _py_List['Point2D'], int: int, point2DArray2: _py_List['Point2D'], int2: int, int3: int) -> None: ...
    def translate(self, double: float, double2: float) -> None: ...

class Area(java.awt.Shape, java.lang.Cloneable):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, shape: java.awt.Shape): ...
    def add(self, area: 'Area') -> None: ...
    def clone(self) -> _py_Any: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def createTransformedArea(self, affineTransform: AffineTransform) -> 'Area': ...
    @overload
    def equals(self, area: 'Area') -> bool: ...
    @overload
    def equals(self, object: _py_Any) -> bool: ...
    def exclusiveOr(self, area: 'Area') -> None: ...
    def getBounds(self) -> java.awt.Rectangle: ...
    def getBounds2D(self) -> 'Rectangle2D': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> 'PathIterator': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> 'PathIterator': ...
    def intersect(self, area: 'Area') -> None: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def isEmpty(self) -> bool: ...
    def isPolygonal(self) -> bool: ...
    def isRectangular(self) -> bool: ...
    def isSingular(self) -> bool: ...
    def reset(self) -> None: ...
    def subtract(self, area: 'Area') -> None: ...
    def transform(self, affineTransform: AffineTransform) -> None: ...

class Dimension2D(java.lang.Cloneable):
    def clone(self) -> _py_Any: ...
    def getHeight(self) -> float: ...
    def getWidth(self) -> float: ...
    @overload
    def setSize(self, double: float, double2: float) -> None: ...
    @overload
    def setSize(self, dimension2D: 'Dimension2D') -> None: ...

class IllegalPathStateException(java.lang.RuntimeException):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, string: str): ...

class NoninvertibleTransformException(java.lang.Exception):
    def __init__(self, string: str): ...

class PathIterator:
    WIND_EVEN_ODD: _py_ClassVar[int] = ...
    WIND_NON_ZERO: _py_ClassVar[int] = ...
    SEG_MOVETO: _py_ClassVar[int] = ...
    SEG_LINETO: _py_ClassVar[int] = ...
    SEG_QUADTO: _py_ClassVar[int] = ...
    SEG_CUBICTO: _py_ClassVar[int] = ...
    SEG_CLOSE: _py_ClassVar[int] = ...
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class RectangularShape(java.awt.Shape, java.lang.Cloneable):
    def clone(self) -> _py_Any: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def getBounds(self) -> java.awt.Rectangle: ...
    def getCenterX(self) -> float: ...
    def getCenterY(self) -> float: ...
    def getFrame(self) -> 'Rectangle2D': ...
    def getHeight(self) -> float: ...
    def getMaxX(self) -> float: ...
    def getMaxY(self) -> float: ...
    def getMinX(self) -> float: ...
    def getMinY(self) -> float: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def getWidth(self) -> float: ...
    def getX(self) -> float: ...
    def getY(self) -> float: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def isEmpty(self) -> bool: ...
    @overload
    def setFrame(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setFrame(self, point2D: 'Point2D', dimension2D: Dimension2D) -> None: ...
    @overload
    def setFrame(self, rectangle2D: 'Rectangle2D') -> None: ...
    @overload
    def setFrameFromCenter(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setFrameFromCenter(self, point2D: 'Point2D', point2D2: 'Point2D') -> None: ...
    @overload
    def setFrameFromDiagonal(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setFrameFromDiagonal(self, point2D: 'Point2D', point2D2: 'Point2D') -> None: ...

class ArcIterator(PathIterator):
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class AreaIterator(PathIterator):
    def __init__(self, vector: java.util.Vector, affineTransform: AffineTransform): ...
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class CubicIterator(PathIterator):
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class EllipseIterator(PathIterator):
    CtrlVal: _py_ClassVar[float] = ...
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class FlatteningPathIterator(PathIterator):
    @overload
    def __init__(self, pathIterator: PathIterator, double: float): ...
    @overload
    def __init__(self, pathIterator: PathIterator, double: float, int: int): ...
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getFlatness(self) -> float: ...
    def getRecursionLimit(self) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class LineIterator(PathIterator):
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class QuadIterator(PathIterator):
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class RectIterator(PathIterator):
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class RoundRectIterator(PathIterator):
    @overload
    def currentSegment(self, doubleArray: _py_List[float]) -> int: ...
    @overload
    def currentSegment(self, floatArray: _py_List[float]) -> int: ...
    def getWindingRule(self) -> int: ...
    def isDone(self) -> bool: ...
    def next(self) -> None: ...

class Arc2D(RectangularShape):
    OPEN: _py_ClassVar[int] = ...
    CHORD: _py_ClassVar[int] = ...
    PIE: _py_ClassVar[int] = ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    def containsAngle(self, double: float) -> bool: ...
    def equals(self, object: _py_Any) -> bool: ...
    def getAngleExtent(self) -> float: ...
    def getAngleStart(self) -> float: ...
    def getArcType(self) -> int: ...
    def getBounds2D(self) -> 'Rectangle2D': ...
    def getEndPoint(self) -> 'Point2D': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def getStartPoint(self) -> 'Point2D': ...
    def hashCode(self) -> int: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def setAngleExtent(self, double: float) -> None: ...
    @overload
    def setAngleStart(self, double: float) -> None: ...
    @overload
    def setAngleStart(self, point2D: 'Point2D') -> None: ...
    @overload
    def setAngles(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setAngles(self, point2D: 'Point2D', point2D2: 'Point2D') -> None: ...
    @overload
    def setArc(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, int: int) -> None: ...
    @overload
    def setArc(self, arc2D: 'Arc2D') -> None: ...
    @overload
    def setArc(self, point2D: 'Point2D', dimension2D: Dimension2D, double: float, double2: float, int: int) -> None: ...
    @overload
    def setArc(self, rectangle2D: 'Rectangle2D', double: float, double2: float, int: int) -> None: ...
    def setArcByCenter(self, double: float, double2: float, double3: float, double4: float, double5: float, int: int) -> None: ...
    def setArcByTangent(self, point2D: 'Point2D', point2D2: 'Point2D', point2D3: 'Point2D', double: float) -> None: ...
    def setArcType(self, int: int) -> None: ...
    @overload
    def setFrame(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setFrame(self, point2D: 'Point2D', dimension2D: Dimension2D) -> None: ...
    @overload
    def setFrame(self, rectangle2D: 'Rectangle2D') -> None: ...
    class Double(java.awt.geom.Arc2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        start: float = ...
        extent: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, int: int): ...
        @overload
        def __init__(self, int: int): ...
        @overload
        def __init__(self, rectangle2D: 'Rectangle2D', double: float, double2: float, int: int): ...
        def getAngleExtent(self) -> float: ...
        def getAngleStart(self) -> float: ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        def setAngleExtent(self, double: float) -> None: ...
        @overload
        def setAngleStart(self, double: float) -> None: ...
        @overload
        def setAngleStart(self, point2D: 'Point2D') -> None: ...
        @overload
        def setArc(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, int: int) -> None: ...
        @overload
        def setArc(self, arc2D: 'Arc2D') -> None: ...
        @overload
        def setArc(self, point2D: 'Point2D', dimension2D: Dimension2D, double: float, double2: float, int: int) -> None: ...
        @overload
        def setArc(self, rectangle2D: 'Rectangle2D', double: float, double2: float, int: int) -> None: ...
    class Float(java.awt.geom.Arc2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        start: float = ...
        extent: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float, int: int): ...
        @overload
        def __init__(self, int: int): ...
        @overload
        def __init__(self, rectangle2D: 'Rectangle2D', float: float, float2: float, int: int): ...
        def getAngleExtent(self) -> float: ...
        def getAngleStart(self) -> float: ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        def setAngleExtent(self, double: float) -> None: ...
        @overload
        def setAngleStart(self, double: float) -> None: ...
        @overload
        def setAngleStart(self, point2D: 'Point2D') -> None: ...
        @overload
        def setArc(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, int: int) -> None: ...
        @overload
        def setArc(self, arc2D: 'Arc2D') -> None: ...
        @overload
        def setArc(self, point2D: 'Point2D', dimension2D: Dimension2D, double: float, double2: float, int: int) -> None: ...
        @overload
        def setArc(self, rectangle2D: 'Rectangle2D', double: float, double2: float, int: int) -> None: ...

class CubicCurve2D(java.awt.Shape, java.lang.Cloneable):
    def clone(self) -> _py_Any: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def getBounds(self) -> java.awt.Rectangle: ...
    def getCtrlP1(self) -> 'Point2D': ...
    def getCtrlP2(self) -> 'Point2D': ...
    def getCtrlX1(self) -> float: ...
    def getCtrlX2(self) -> float: ...
    def getCtrlY1(self) -> float: ...
    def getCtrlY2(self) -> float: ...
    @overload
    def getFlatness(self) -> float: ...
    @classmethod
    @overload
    def getFlatness(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float) -> float: ...
    @classmethod
    @overload
    def getFlatness(cls, doubleArray: _py_List[float], int: int) -> float: ...
    @overload
    def getFlatnessSq(self) -> float: ...
    @classmethod
    @overload
    def getFlatnessSq(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float) -> float: ...
    @classmethod
    @overload
    def getFlatnessSq(cls, doubleArray: _py_List[float], int: int) -> float: ...
    def getP1(self) -> 'Point2D': ...
    def getP2(self) -> 'Point2D': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def getX1(self) -> float: ...
    def getX2(self) -> float: ...
    def getY1(self) -> float: ...
    def getY2(self) -> float: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @overload
    def setCurve(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float) -> None: ...
    @overload
    def setCurve(self, doubleArray: _py_List[float], int: int) -> None: ...
    @overload
    def setCurve(self, cubicCurve2D: 'CubicCurve2D') -> None: ...
    @overload
    def setCurve(self, point2D: 'Point2D', point2D2: 'Point2D', point2D3: 'Point2D', point2D4: 'Point2D') -> None: ...
    @overload
    def setCurve(self, point2DArray: _py_List['Point2D'], int: int) -> None: ...
    @classmethod
    @overload
    def solveCubic(cls, doubleArray: _py_List[float]) -> int: ...
    @classmethod
    @overload
    def solveCubic(cls, doubleArray: _py_List[float], doubleArray2: _py_List[float]) -> int: ...
    @classmethod
    @overload
    def subdivide(cls, doubleArray: _py_List[float], int: int, doubleArray2: _py_List[float], int2: int, doubleArray3: _py_List[float], int3: int) -> None: ...
    @classmethod
    @overload
    def subdivide(cls, cubicCurve2D: 'CubicCurve2D', cubicCurve2D2: 'CubicCurve2D', cubicCurve2D3: 'CubicCurve2D') -> None: ...
    @overload
    def subdivide(self, cubicCurve2D: 'CubicCurve2D', cubicCurve2D2: 'CubicCurve2D') -> None: ...
    class Double(java.awt.geom.CubicCurve2D, java.io.Serializable):
        x1: float = ...
        y1: float = ...
        ctrlx1: float = ...
        ctrly1: float = ...
        ctrlx2: float = ...
        ctrly2: float = ...
        x2: float = ...
        y2: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getCtrlP1(self) -> 'Point2D': ...
        def getCtrlP2(self) -> 'Point2D': ...
        def getCtrlX1(self) -> float: ...
        def getCtrlX2(self) -> float: ...
        def getCtrlY1(self) -> float: ...
        def getCtrlY2(self) -> float: ...
        def getP1(self) -> 'Point2D': ...
        def getP2(self) -> 'Point2D': ...
        def getX1(self) -> float: ...
        def getX2(self) -> float: ...
        def getY1(self) -> float: ...
        def getY2(self) -> float: ...
        @overload
        def setCurve(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float) -> None: ...
        @overload
        def setCurve(self, doubleArray: _py_List[float], int: int) -> None: ...
        @overload
        def setCurve(self, cubicCurve2D: 'CubicCurve2D') -> None: ...
        @overload
        def setCurve(self, point2D: 'Point2D', point2D2: 'Point2D', point2D3: 'Point2D', point2D4: 'Point2D') -> None: ...
        @overload
        def setCurve(self, point2DArray: _py_List['Point2D'], int: int) -> None: ...
    class Float(java.awt.geom.CubicCurve2D, java.io.Serializable):
        x1: float = ...
        y1: float = ...
        ctrlx1: float = ...
        ctrly1: float = ...
        ctrlx2: float = ...
        ctrly2: float = ...
        x2: float = ...
        y2: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float, float7: float, float8: float): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getCtrlP1(self) -> 'Point2D': ...
        def getCtrlP2(self) -> 'Point2D': ...
        def getCtrlX1(self) -> float: ...
        def getCtrlX2(self) -> float: ...
        def getCtrlY1(self) -> float: ...
        def getCtrlY2(self) -> float: ...
        def getP1(self) -> 'Point2D': ...
        def getP2(self) -> 'Point2D': ...
        def getX1(self) -> float: ...
        def getX2(self) -> float: ...
        def getY1(self) -> float: ...
        def getY2(self) -> float: ...
        @overload
        def setCurve(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float) -> None: ...
        @overload
        def setCurve(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float, float7: float, float8: float) -> None: ...
        @overload
        def setCurve(self, doubleArray: _py_List[float], int: int) -> None: ...
        @overload
        def setCurve(self, cubicCurve2D: 'CubicCurve2D') -> None: ...
        @overload
        def setCurve(self, point2D: 'Point2D', point2D2: 'Point2D', point2D3: 'Point2D', point2D4: 'Point2D') -> None: ...
        @overload
        def setCurve(self, point2DArray: _py_List['Point2D'], int: int) -> None: ...

class Ellipse2D(RectangularShape):
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def equals(self, object: _py_Any) -> bool: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def hashCode(self) -> int: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    class Double(java.awt.geom.Ellipse2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        @overload
        def setFrame(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def setFrame(self, point2D: 'Point2D', dimension2D: Dimension2D) -> None: ...
        @overload
        def setFrame(self, rectangle2D: 'Rectangle2D') -> None: ...
    class Float(java.awt.geom.Ellipse2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        @overload
        def setFrame(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def setFrame(self, float: float, float2: float, float3: float, float4: float) -> None: ...
        @overload
        def setFrame(self, point2D: 'Point2D', dimension2D: Dimension2D) -> None: ...
        @overload
        def setFrame(self, rectangle2D: 'Rectangle2D') -> None: ...

class GeneralPath(java.awt.geom.Path2D.Float):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, int: int): ...
    @overload
    def __init__(self, int: int, int2: int): ...
    @overload
    def __init__(self, shape: java.awt.Shape): ...

class Line2D(java.awt.Shape, java.lang.Cloneable):
    def clone(self) -> _py_Any: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def getBounds(self) -> java.awt.Rectangle: ...
    def getP1(self) -> 'Point2D': ...
    def getP2(self) -> 'Point2D': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def getX1(self) -> float: ...
    def getX2(self) -> float: ...
    def getY1(self) -> float: ...
    def getY2(self) -> float: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @overload
    def intersectsLine(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersectsLine(self, line2D: 'Line2D') -> bool: ...
    @classmethod
    def linesIntersect(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float, double7: float, double8: float) -> bool: ...
    @overload
    def ptLineDist(self, double: float, double2: float) -> float: ...
    @overload
    def ptLineDist(self, point2D: 'Point2D') -> float: ...
    @classmethod
    @overload
    def ptLineDist(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> float: ...
    @overload
    def ptLineDistSq(self, double: float, double2: float) -> float: ...
    @overload
    def ptLineDistSq(self, point2D: 'Point2D') -> float: ...
    @classmethod
    @overload
    def ptLineDistSq(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> float: ...
    @overload
    def ptSegDist(self, double: float, double2: float) -> float: ...
    @overload
    def ptSegDist(self, point2D: 'Point2D') -> float: ...
    @classmethod
    @overload
    def ptSegDist(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> float: ...
    @overload
    def ptSegDistSq(self, double: float, double2: float) -> float: ...
    @overload
    def ptSegDistSq(self, point2D: 'Point2D') -> float: ...
    @classmethod
    @overload
    def ptSegDistSq(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> float: ...
    @overload
    def relativeCCW(self, double: float, double2: float) -> int: ...
    @overload
    def relativeCCW(self, point2D: 'Point2D') -> int: ...
    @classmethod
    @overload
    def relativeCCW(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> int: ...
    @overload
    def setLine(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setLine(self, line2D: 'Line2D') -> None: ...
    @overload
    def setLine(self, point2D: 'Point2D', point2D2: 'Point2D') -> None: ...
    class Double(java.awt.geom.Line2D, java.io.Serializable):
        x1: float = ...
        y1: float = ...
        x2: float = ...
        y2: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float): ...
        @overload
        def __init__(self, point2D: 'Point2D', point2D2: 'Point2D'): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getP1(self) -> 'Point2D': ...
        def getP2(self) -> 'Point2D': ...
        def getX1(self) -> float: ...
        def getX2(self) -> float: ...
        def getY1(self) -> float: ...
        def getY2(self) -> float: ...
        @overload
        def setLine(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def setLine(self, line2D: 'Line2D') -> None: ...
        @overload
        def setLine(self, point2D: 'Point2D', point2D2: 'Point2D') -> None: ...
    class Float(java.awt.geom.Line2D, java.io.Serializable):
        x1: float = ...
        y1: float = ...
        x2: float = ...
        y2: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float): ...
        @overload
        def __init__(self, point2D: 'Point2D', point2D2: 'Point2D'): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getP1(self) -> 'Point2D': ...
        def getP2(self) -> 'Point2D': ...
        def getX1(self) -> float: ...
        def getX2(self) -> float: ...
        def getY1(self) -> float: ...
        def getY2(self) -> float: ...
        @overload
        def setLine(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def setLine(self, float: float, float2: float, float3: float, float4: float) -> None: ...
        @overload
        def setLine(self, line2D: 'Line2D') -> None: ...
        @overload
        def setLine(self, point2D: 'Point2D', point2D2: 'Point2D') -> None: ...

class Path2D(java.awt.Shape, java.lang.Cloneable):
    WIND_EVEN_ODD: _py_ClassVar[int] = ...
    WIND_NON_ZERO: _py_ClassVar[int] = ...
    @overload
    def append(self, pathIterator: PathIterator, boolean: bool) -> None: ...
    @overload
    def append(self, shape: java.awt.Shape, boolean: bool) -> None: ...
    def clone(self) -> _py_Any: ...
    def closePath(self) -> None: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: 'Point2D') -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @classmethod
    @overload
    def contains(cls, pathIterator: PathIterator, double: float, double2: float) -> bool: ...
    @classmethod
    @overload
    def contains(cls, pathIterator: PathIterator, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @classmethod
    @overload
    def contains(cls, pathIterator: PathIterator, point2D: 'Point2D') -> bool: ...
    @classmethod
    @overload
    def contains(cls, pathIterator: PathIterator, rectangle2D: 'Rectangle2D') -> bool: ...
    def createTransformedShape(self, affineTransform: AffineTransform) -> java.awt.Shape: ...
    def curveTo(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
    def getBounds(self) -> java.awt.Rectangle: ...
    def getCurrentPoint(self) -> 'Point2D': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def getWindingRule(self) -> int: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @classmethod
    @overload
    def intersects(cls, pathIterator: PathIterator, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @classmethod
    @overload
    def intersects(cls, pathIterator: PathIterator, rectangle2D: 'Rectangle2D') -> bool: ...
    def lineTo(self, double: float, double2: float) -> None: ...
    def moveTo(self, double: float, double2: float) -> None: ...
    def quadTo(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    def reset(self) -> None: ...
    def setWindingRule(self, int: int) -> None: ...
    def transform(self, affineTransform: AffineTransform) -> None: ...
    class Double(java.awt.geom.Path2D, java.io.Serializable):
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, int: int): ...
        @overload
        def __init__(self, int: int, int2: int): ...
        @overload
        def __init__(self, shape: java.awt.Shape): ...
        @overload
        def __init__(self, shape: java.awt.Shape, affineTransform: AffineTransform): ...
        @overload
        def append(self, pathIterator: PathIterator, boolean: bool) -> None: ...
        @overload
        def append(self, shape: java.awt.Shape, boolean: bool) -> None: ...
        def clone(self) -> _py_Any: ...
        def curveTo(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        @overload
        def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
        @overload
        def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
        def lineTo(self, double: float, double2: float) -> None: ...
        def moveTo(self, double: float, double2: float) -> None: ...
        def quadTo(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        def transform(self, affineTransform: AffineTransform) -> None: ...
    class Float(java.awt.geom.Path2D, java.io.Serializable):
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, int: int): ...
        @overload
        def __init__(self, int: int, int2: int): ...
        @overload
        def __init__(self, shape: java.awt.Shape): ...
        @overload
        def __init__(self, shape: java.awt.Shape, affineTransform: AffineTransform): ...
        @overload
        def append(self, pathIterator: PathIterator, boolean: bool) -> None: ...
        @overload
        def append(self, shape: java.awt.Shape, boolean: bool) -> None: ...
        def clone(self) -> _py_Any: ...
        @overload
        def curveTo(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
        @overload
        def curveTo(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float) -> None: ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        @overload
        def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
        @overload
        def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
        @overload
        def lineTo(self, double: float, double2: float) -> None: ...
        @overload
        def lineTo(self, float: float, float2: float) -> None: ...
        @overload
        def moveTo(self, double: float, double2: float) -> None: ...
        @overload
        def moveTo(self, float: float, float2: float) -> None: ...
        @overload
        def quadTo(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def quadTo(self, float: float, float2: float, float3: float, float4: float) -> None: ...
        def transform(self, affineTransform: AffineTransform) -> None: ...

class Point2D(java.lang.Cloneable):
    def clone(self) -> _py_Any: ...
    @overload
    def distance(self, double: float, double2: float) -> float: ...
    @overload
    def distance(self, point2D: 'Point2D') -> float: ...
    @classmethod
    @overload
    def distance(cls, double: float, double2: float, double3: float, double4: float) -> float: ...
    @overload
    def distanceSq(self, double: float, double2: float) -> float: ...
    @overload
    def distanceSq(self, point2D: 'Point2D') -> float: ...
    @classmethod
    @overload
    def distanceSq(cls, double: float, double2: float, double3: float, double4: float) -> float: ...
    def equals(self, object: _py_Any) -> bool: ...
    def getX(self) -> float: ...
    def getY(self) -> float: ...
    def hashCode(self) -> int: ...
    @overload
    def setLocation(self, double: float, double2: float) -> None: ...
    @overload
    def setLocation(self, point2D: 'Point2D') -> None: ...
    class Double(java.awt.geom.Point2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float): ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        @overload
        def setLocation(self, double: float, double2: float) -> None: ...
        @overload
        def setLocation(self, point2D: 'Point2D') -> None: ...
        def toString(self) -> str: ...
    class Float(java.awt.geom.Point2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float): ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        @overload
        def setLocation(self, double: float, double2: float) -> None: ...
        @overload
        def setLocation(self, float: float, float2: float) -> None: ...
        @overload
        def setLocation(self, point2D: 'Point2D') -> None: ...
        def toString(self) -> str: ...

class QuadCurve2D(java.awt.Shape, java.lang.Cloneable):
    def clone(self) -> _py_Any: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: Point2D) -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def getBounds(self) -> java.awt.Rectangle: ...
    def getCtrlPt(self) -> Point2D: ...
    def getCtrlX(self) -> float: ...
    def getCtrlY(self) -> float: ...
    @overload
    def getFlatness(self) -> float: ...
    @classmethod
    @overload
    def getFlatness(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> float: ...
    @classmethod
    @overload
    def getFlatness(cls, doubleArray: _py_List[float], int: int) -> float: ...
    @overload
    def getFlatnessSq(self) -> float: ...
    @classmethod
    @overload
    def getFlatnessSq(cls, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> float: ...
    @classmethod
    @overload
    def getFlatnessSq(cls, doubleArray: _py_List[float], int: int) -> float: ...
    def getP1(self) -> Point2D: ...
    def getP2(self) -> Point2D: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def getX1(self) -> float: ...
    def getX2(self) -> float: ...
    def getY1(self) -> float: ...
    def getY2(self) -> float: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @overload
    def setCurve(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
    @overload
    def setCurve(self, doubleArray: _py_List[float], int: int) -> None: ...
    @overload
    def setCurve(self, point2D: Point2D, point2D2: Point2D, point2D3: Point2D) -> None: ...
    @overload
    def setCurve(self, point2DArray: _py_List[Point2D], int: int) -> None: ...
    @overload
    def setCurve(self, quadCurve2D: 'QuadCurve2D') -> None: ...
    @classmethod
    @overload
    def solveQuadratic(cls, doubleArray: _py_List[float]) -> int: ...
    @classmethod
    @overload
    def solveQuadratic(cls, doubleArray: _py_List[float], doubleArray2: _py_List[float]) -> int: ...
    @classmethod
    @overload
    def subdivide(cls, doubleArray: _py_List[float], int: int, doubleArray2: _py_List[float], int2: int, doubleArray3: _py_List[float], int3: int) -> None: ...
    @classmethod
    @overload
    def subdivide(cls, quadCurve2D: 'QuadCurve2D', quadCurve2D2: 'QuadCurve2D', quadCurve2D3: 'QuadCurve2D') -> None: ...
    @overload
    def subdivide(self, quadCurve2D: 'QuadCurve2D', quadCurve2D2: 'QuadCurve2D') -> None: ...
    class Double(java.awt.geom.QuadCurve2D, java.io.Serializable):
        x1: float = ...
        y1: float = ...
        ctrlx: float = ...
        ctrly: float = ...
        x2: float = ...
        y2: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getCtrlPt(self) -> Point2D: ...
        def getCtrlX(self) -> float: ...
        def getCtrlY(self) -> float: ...
        def getP1(self) -> Point2D: ...
        def getP2(self) -> Point2D: ...
        def getX1(self) -> float: ...
        def getX2(self) -> float: ...
        def getY1(self) -> float: ...
        def getY2(self) -> float: ...
        @overload
        def setCurve(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
        @overload
        def setCurve(self, doubleArray: _py_List[float], int: int) -> None: ...
        @overload
        def setCurve(self, point2D: Point2D, point2D2: Point2D, point2D3: Point2D) -> None: ...
        @overload
        def setCurve(self, point2DArray: _py_List[Point2D], int: int) -> None: ...
        @overload
        def setCurve(self, quadCurve2D: 'QuadCurve2D') -> None: ...
    class Float(java.awt.geom.QuadCurve2D, java.io.Serializable):
        x1: float = ...
        y1: float = ...
        ctrlx: float = ...
        ctrly: float = ...
        x2: float = ...
        y2: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float): ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getCtrlPt(self) -> Point2D: ...
        def getCtrlX(self) -> float: ...
        def getCtrlY(self) -> float: ...
        def getP1(self) -> Point2D: ...
        def getP2(self) -> Point2D: ...
        def getX1(self) -> float: ...
        def getX2(self) -> float: ...
        def getY1(self) -> float: ...
        def getY2(self) -> float: ...
        @overload
        def setCurve(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
        @overload
        def setCurve(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float) -> None: ...
        @overload
        def setCurve(self, doubleArray: _py_List[float], int: int) -> None: ...
        @overload
        def setCurve(self, point2D: Point2D, point2D2: Point2D, point2D3: Point2D) -> None: ...
        @overload
        def setCurve(self, point2DArray: _py_List[Point2D], int: int) -> None: ...
        @overload
        def setCurve(self, quadCurve2D: 'QuadCurve2D') -> None: ...

class Rectangle2D(RectangularShape):
    OUT_LEFT: _py_ClassVar[int] = ...
    OUT_TOP: _py_ClassVar[int] = ...
    OUT_RIGHT: _py_ClassVar[int] = ...
    OUT_BOTTOM: _py_ClassVar[int] = ...
    @overload
    def add(self, double: float, double2: float) -> None: ...
    @overload
    def add(self, point2D: Point2D) -> None: ...
    @overload
    def add(self, rectangle2D: 'Rectangle2D') -> None: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def contains(self, point2D: Point2D) -> bool: ...
    @overload
    def contains(self, rectangle2D: 'Rectangle2D') -> bool: ...
    def createIntersection(self, rectangle2D: 'Rectangle2D') -> 'Rectangle2D': ...
    def createUnion(self, rectangle2D: 'Rectangle2D') -> 'Rectangle2D': ...
    def equals(self, object: _py_Any) -> bool: ...
    def getBounds2D(self) -> 'Rectangle2D': ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    def hashCode(self) -> int: ...
    @classmethod
    def intersect(cls, rectangle2D: 'Rectangle2D', rectangle2D2: 'Rectangle2D', rectangle2D3: 'Rectangle2D') -> None: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersects(self, rectangle2D: 'Rectangle2D') -> bool: ...
    @overload
    def intersectsLine(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def intersectsLine(self, line2D: Line2D) -> bool: ...
    @overload
    def outcode(self, double: float, double2: float) -> int: ...
    @overload
    def outcode(self, point2D: Point2D) -> int: ...
    @overload
    def setFrame(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setFrame(self, point2D: Point2D, dimension2D: Dimension2D) -> None: ...
    @overload
    def setFrame(self, rectangle2D: 'Rectangle2D') -> None: ...
    @overload
    def setRect(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setRect(self, rectangle2D: 'Rectangle2D') -> None: ...
    @classmethod
    def union(cls, rectangle2D: 'Rectangle2D', rectangle2D2: 'Rectangle2D', rectangle2D3: 'Rectangle2D') -> None: ...
    class Double(java.awt.geom.Rectangle2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float): ...
        def createIntersection(self, rectangle2D: 'Rectangle2D') -> 'Rectangle2D': ...
        def createUnion(self, rectangle2D: 'Rectangle2D') -> 'Rectangle2D': ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        @overload
        def outcode(self, double: float, double2: float) -> int: ...
        @overload
        def outcode(self, point2D: Point2D) -> int: ...
        @overload
        def setRect(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def setRect(self, rectangle2D: 'Rectangle2D') -> None: ...
        def toString(self) -> str: ...
    class Float(java.awt.geom.Rectangle2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float): ...
        def createIntersection(self, rectangle2D: 'Rectangle2D') -> 'Rectangle2D': ...
        def createUnion(self, rectangle2D: 'Rectangle2D') -> 'Rectangle2D': ...
        def getBounds2D(self) -> 'Rectangle2D': ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        @overload
        def outcode(self, double: float, double2: float) -> int: ...
        @overload
        def outcode(self, point2D: Point2D) -> int: ...
        @overload
        def setRect(self, double: float, double2: float, double3: float, double4: float) -> None: ...
        @overload
        def setRect(self, float: float, float2: float, float3: float, float4: float) -> None: ...
        @overload
        def setRect(self, rectangle2D: 'Rectangle2D') -> None: ...
        def toString(self) -> str: ...

class RoundRectangle2D(RectangularShape):
    @overload
    def contains(self, point2D: Point2D) -> bool: ...
    @overload
    def contains(self, rectangle2D: Rectangle2D) -> bool: ...
    @overload
    def contains(self, double: float, double2: float) -> bool: ...
    @overload
    def contains(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    def equals(self, object: _py_Any) -> bool: ...
    def getArcHeight(self) -> float: ...
    def getArcWidth(self) -> float: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform, double: float) -> PathIterator: ...
    @overload
    def getPathIterator(self, affineTransform: AffineTransform) -> PathIterator: ...
    def hashCode(self) -> int: ...
    @overload
    def intersects(self, rectangle2D: Rectangle2D) -> bool: ...
    @overload
    def intersects(self, double: float, double2: float, double3: float, double4: float) -> bool: ...
    @overload
    def setFrame(self, point2D: Point2D, dimension2D: Dimension2D) -> None: ...
    @overload
    def setFrame(self, rectangle2D: Rectangle2D) -> None: ...
    @overload
    def setFrame(self, double: float, double2: float, double3: float, double4: float) -> None: ...
    @overload
    def setRoundRect(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
    @overload
    def setRoundRect(self, roundRectangle2D: 'RoundRectangle2D') -> None: ...
    class Double(java.awt.geom.RoundRectangle2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        arcwidth: float = ...
        archeight: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float): ...
        def getArcHeight(self) -> float: ...
        def getArcWidth(self) -> float: ...
        def getBounds2D(self) -> Rectangle2D: ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        @overload
        def setRoundRect(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
        @overload
        def setRoundRect(self, roundRectangle2D: 'RoundRectangle2D') -> None: ...
    class Float(java.awt.geom.RoundRectangle2D, java.io.Serializable):
        x: float = ...
        y: float = ...
        width: float = ...
        height: float = ...
        arcwidth: float = ...
        archeight: float = ...
        @overload
        def __init__(self): ...
        @overload
        def __init__(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float): ...
        def getArcHeight(self) -> float: ...
        def getArcWidth(self) -> float: ...
        def getBounds2D(self) -> Rectangle2D: ...
        def getHeight(self) -> float: ...
        def getWidth(self) -> float: ...
        def getX(self) -> float: ...
        def getY(self) -> float: ...
        def isEmpty(self) -> bool: ...
        @overload
        def setRoundRect(self, double: float, double2: float, double3: float, double4: float, double5: float, double6: float) -> None: ...
        @overload
        def setRoundRect(self, float: float, float2: float, float3: float, float4: float, float5: float, float6: float) -> None: ...
        @overload
        def setRoundRect(self, roundRectangle2D: 'RoundRectangle2D') -> None: ...
